%define          localstatedir /var/lib

Name:            flux
Version:         0.9.1
Release:         0.hpj.1

Summary:         Multipurpose C library based on GLib
Copyright:       LGPL
Group:           Libraries
URL:             http://www.fluxlib.org/
Packager:        Hans Petter Jansson <hpj@copyleft.no>

Source:          %{name}-%{version}.tar.gz
BuildRoot:       /var/tmp/%{name}-%{version}-root
Requires:        glib2 >= 2.0.0
Requires:        gmp >= 3.0.1
Requires:        zlib >= 1.1.0
BuildRequires:   glib2-devel >= 2.0.0
BuildRequires:   gmp-devel >= 3.0.1
BuildRequires:   zlib-devel >= 1.1.0

%description
Flux is a small multi-purpose C library based on GLib.

Comments and questions should be sent to <hpj@copyleft.no>.
The Flux homepage is at <http://www.fluxlib.org/>.

%package devel
Summary:         Development files for the Flux library
Group:           Development/Libraries
Requires:        %{name} = %{version}
Requires:        glib2-devel >= 2.0.0
Requires:        gmp-devel >= 3.0.1
Requires:        zlib-devel >= 1.1.0

%description devel
Flux is a small multi-purpose C library based on GLib. This package
allows you to develop applications that use the Flux library.

%prep
%setup

%build

%ifarch alpha
    MYARCH_FLAGS="--host=alpha-redhat-linux"
%endif

# Needed for snapshot releases.
MYCFLAGS="$RPM_OPT_FLAGS"

if [ ! -f configure ]; then
    CFLAGS="$MYCFLAGS" ./autogen.sh $MYARCH_FLAGS \
	--enable-more-warnings --prefix=%{_prefix} \
	--localstatedir=%{localstatedir} --sysconfdir=%{_sysconfdir} \
	--mandir=%{_mandir} --libdir=%{_libdir} \
	--includedir=%{_includedir} --bindir=%{_bindir}
fi

CFLAGS="$MYCFLAGS" ./configure $MYARCH_FLAGS --enable-more-warnings \
    --prefix=%{_prefix} --localstatedir=%{localstatedir} \
    --sysconfdir=%{_sysconfdir} --mandir=%{_mandir} \
    --libdir=%{_libdir} --includedir=%{_includedir} \
    --bindir=%{_bindir} 

make

%install
rm -rf $RPM_BUILD_ROOT
make -k sysconfdir=$RPM_BUILD_ROOT%{_sysconfdir} \
    prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
    libdir=$RPM_BUILD_ROOT%{_libdir} bindir=$RPM_BUILD_ROOT\%{_bindir} \
    includedir=$RPM_BUILD_ROOT%{_includedir} install

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)

%doc README COPYING ChangeLog NEWS AUTHORS INSTALL
%{_libdir}/*.so.*
%{_libdir}/*.so

%files devel
%defattr(-, root, root)
%{_includedir}/%{name}
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/pkgconfig/*.pc
%{_prefix}/share/gtk-doc/html/%{name}

%changelog
* Sat Mar 22 2003 Hans Petter Jansson <hpj@copyleft.no>
- Wrote initial spec file.
