/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* flux-bin-path.h - Path through binary tree.
 *
 * Copyright (C) 2004 Hans Petter Jansson
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authors: Hans Petter Jansson <hpj@copyleft.no>
 */

#ifndef FLUX_BIN_PATH_H
#define FLUX_BIN_PATH_H

#ifdef __FLUX_BUILD
# include "flux-types.h"
# include "flux-object.h"
# include "flux-bool-array.h"
#else
# include <flux/flux-types.h>
# include <flux/flux-object.h>
# include <flux/flux-bool-array.h>
#endif

#define FLUX_BIN_PATH(object) ((FluxBinPath *) (object))

struct _FluxBinPath
{
  FluxBoolArray bool_array;
};

FluxBinPath     *flux_bin_path_new             (void);
void             flux_bin_path_init            (FluxBinPath *bin_path);
void             flux_bin_path_finalize        (FluxObject *bin_path);

guint            flux_bin_path_get_depth       (FluxBinPath *bin_path);

void             flux_bin_path_left            (FluxBinPath *bin_path);
void             flux_bin_path_right           (FluxBinPath *bin_path);
void             flux_bin_path_up              (FluxBinPath *bin_path);

gboolean         flux_bin_path_get_value       (FluxBinPath *bin_path, guint depth);

#endif  /* FLUX_BIN_PATH_H */
