/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* flux-cursor.c - Abstract class for data structure cursors.
 *
 * Copyright (C) 2001-2003 Hans Petter Jansson
 *
 * Flux is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * Authors: Hans Petter Jansson <hpj@copyleft.no>
 */

#include "config.h"
#include <glib.h>

#include "flux-cursor.h"

#define assert_types(o) flux_object_check (FLUX_OBJECT (o), FLUX_CURSOR_TYPE)

void
flux_cursor_init (FluxCursor *cursor)
{
  flux_object_init              (FLUX_OBJECT (cursor));
  flux_object_set_type          (FLUX_OBJECT (cursor), FLUX_CURSOR_TYPE);
  flux_object_set_finalize_func (FLUX_OBJECT (cursor), (FluxFinalizeFunc *) flux_cursor_finalize);

  cursor->next = NULL;
}

void
flux_cursor_finalize (FluxObject *object)
{
}

gboolean
flux_cursor_next (FluxCursor *cursor)
{
  assert_types (cursor);
  g_assert (cursor->next);

  return cursor->next (cursor);
}
