/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* flux-info.h - Compiled-in information about the library.
 *
 * Copyright (C) 2001-2003 Hans Petter Jansson
 *
 * Flux is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * Authors: Hans Petter Jansson <hpj@copyleft.no>
 */

#ifndef _FLUX_INFO_H
#define _FLUX_INFO_H

#ifdef __FLUX_BUILD
# include "flux-types.h"
#else
# include <flux/flux-types.h>
#endif

#include <glib.h>

const gchar *flux_info_get_package          (void);
const gchar *flux_info_get_version          (void);
const gchar *flux_info_get_build_host       (void);
const gchar *flux_info_get_build_os         (void);
const gchar *flux_info_get_build_cc         (void);
const gchar *flux_info_get_build_c_features (void);
const gchar *flux_info_get_build_cpu        (void);
const gchar *flux_info_get_build_time       (void);

#endif /* _FLUX_INFO_H */
