/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* flux-mem-heap.h - Storage backend: In-memory heap.
 *
 * Copyright (C) 2003 Hans Petter Jansson
 *
 * Flux is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * Authors: Hans Petter Jansson <hpj@copyleft.no>
 */

#ifndef _FLUX_MEM_HEAP_H
#define _FLUX_MEM_HEAP_H

#ifdef __FLUX_BUILD
# include "flux-types.h"
# include "flux-storage.h"
#else
# include <flux/flux-types.h>
# include <flux/flux-storage.h>
#endif

#define FLUX_MEM_HEAP(object) ((FluxMemHeap *) object)

struct _FluxMemHeap
{
  FluxStorage storage;

  GHashTable *tag_table;
  GHashTable *alloc_table;
  guint       size;
};

FluxMemHeap *flux_mem_heap_new      (void);
void         flux_mem_heap_init     (FluxMemHeap *mem_heap);
void         flux_mem_heap_finalize (FluxObject *mem_heap);

#endif  /* _FLUX_MEM_HEAP_H */
