/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* flux-rng.h - Entropy-gathering random number generator.
 *
 * Copyright (C) 2001-2003 Hans Petter Jansson
 *
 * Flux is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * Authors: Hans Petter Jansson <hpj@copyleft.no>
 */

#ifndef _FLUX_RNG_H
#define _FLUX_RNG_H

#ifdef __FLUX_BUILD
# include "flux-types.h"
# include "flux-object.h"
#else
# include <flux/flux-types.h>
# include <flux/flux-object.h>
#endif

#include <glib.h>

struct _FluxRng
{
  FluxObject object;

  guchar    *pool;
  guint      len;
  guint      get_pos, insert_pos;
};

FluxRng *flux_rng_new       (void);
void     flux_rng_init      (FluxRng *rng);
void     flux_rng_finalize  (FluxRng *rng);
void     flux_rng_get_bytes (FluxRng *rng, gpointer out, guint len);
guint    flux_rng_get_guint (FluxRng *rng);

#endif /* _FLUX_RNG_H */
