/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* flux-stream-util.h - Utilities for block-oriented stream processing.
 *
 * Copyright (C) 2001-2003 Hans Petter Jansson
 *
 * Flux is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * Authors: Hans Petter Jansson <hpj@copyleft.no>
 */

#ifndef _FLUX_STREAM_PROCESSING_H
#define _FLUX_STREAM_PROCESSING_H

#ifdef __FLUX_BUILD
# include "flux-types.h"
#else
# include <flux/flux-types.h>
#endif

gint flux_stream_process      (gpointer source,
                               guint block_size,
                               guint max_size,
                               FluxStreamProcessorFunc *processor,
                               FluxStreamReaderFunc *reader,
                               gpointer data);

gint flux_stream_process_dual (gpointer source1,
                               gpointer source2,
                               guint block_size,
                               guint max_size,
                               FluxStreamDualProcessorFunc *processor,
                               FluxStreamReaderFunc *reader1,
                               FluxStreamReaderFunc *reader2,
                               gpointer data);

#endif /* _FLUX_STREAM_PROCESSING_H */
