/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* flux-string-util.h - Simple string utilities.
 *
 * Copyright (C) 2001-2003 Hans Petter Jansson
 *
 * Flux is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * Authors: Hans Petter Jansson <hpj@copyleft.no>
 */

#ifndef _FLUX_STRING_UTIL_H
#define _FLUX_STRING_UTIL_H

#ifdef __FLUX_BUILD
# include "flux-types.h"
#else
# include <flux/flux-types.h>
#endif

#define FLUX_STATIC_STRING_LEN(str) (sizeof (str) - 1)
#define FLUX_STRING_WITH_LEN(str)   (str), FLUX_STATIC_STRING_LEN (str)
#define FLUX_STRING_NOT_NULL(str)   ((str) ? (str) : "")
#define FLUX_STRING_IS_EMPTY(str)   (!(str) || *(str) == '\0')

gint    flux_memcasecmp (const guchar *p0, const guchar *p1, guint len);
gint    flux_memcspn    (const guchar *s, guint len, const guchar *reject);
void    flux_memlwr     (guchar *s, guint len);
guchar *flux_memrchr    (const guchar *s, guchar c, gint n);
gint    flux_memspn     (const guchar *s, guint len, const guchar *accept);
void    flux_memupr     (guchar *s, guint len);

#endif  /* _FLUX_STRING_UTIL_H */
