/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* win32-compat.h - Unix-style definitions for win32.
 *
 * Copyright (C) 2004 Hans Petter Jansson
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authors: Hans Petter Jansson <hpj@copyleft.no>
 */

#ifndef FLUX_WIN32_COMPAT_H
#define FLUX_WIN32_COMPAT_H

/* MSVC stuff */

# undef mode_t
# undef R_OK
# undef W_OK
# undef X_OK
# undef F_OK
# undef S_IRUSR
# undef S_IWUSR
# undef S_IXUSR
# undef S_IRWXU
# undef S_ISDIR

# define mode_t short
# define R_OK 4
# define W_OK 2
# define X_OK 0
# define F_OK 0
# define S_IRUSR _S_IREAD
# define S_IWUSR _S_IWRITE
# define S_IXUSR _S_IEXEC
# define S_IRWXU (S_IRUSR | S_IWUSR | S_IXUSR)

# define strcasecmp  stricmp
# define strncasecmp strnicmp

#define S_ISDIR(mode) ((mode) & _S_IFDIR ? TRUE : FALSE)
#define S_ISREG(mode) ((mode) & _S_IFREG ? TRUE : FALSE)

#define open  _open
#define close _close
#define read  _read
#define write _write
#define fstat _fstat
#define lseek _lseek
#define rmdir _rmdir
#define stat  _stat

#endif  /* FLUX_WIN32_COMPAT_H */
